/**************************************************************************
 * Quicker_demo.c
 *  2018/03/29
 * 		By Raiden Lan
 *************************************************************************/
#include <stdio.h> 
#include <stdlib.h>
#include <string.h>
#include <unistd.h> 
#include <fcntl.h>
#include <sys/types.h>
#include "Quicker.h"

void print_usage(char *name)
{
  printf("====================\n");
  printf(" Usage : %s Set/Get Char/Short/Long/ULong/Int64/Float/Double/Str Address(1~1024) (Value)\n", name);  
  printf(" Ex : %s Set Char 1 0\n", name);
  printf(" Ex : %s Get Char 1\n", name);
  printf(" Ex : %s Set Str 1 hello\n", name);
  printf(" Ex : %s Get Str 1\n", name);
  printf("====================\n");
}

int main(int argc, char *argv[])
{
	int ret;
	int addr;
	int rw_flag=0;
	int type=0;
	// for value
	char c_value;
	short s_value;
	long l_value;
	unsigned long ul_value;
	long long ll_value;
	float f_value;
	double d_value;
	char str_value[256];
	
	
  if((argc != 5)&&(argc != 4))
	{
		print_usage(argv[0]);
		return -1;
	}
	else {
    if (strstr(argv[1], "Set")) rw_flag=1;
    else if (strstr(argv[1], "Get")) rw_flag=0;
    else {
      print_usage(argv[0]);
		  return -1;
    }
    if ((rw_flag==1) && (argc!=5)) {
      print_usage(argv[0]);
		  return -1;
    }
    if ((rw_flag==0) && (argc!=4)) {
      print_usage(argv[0]);
		  return -1;
    }
    
    if (strstr(argv[2], "Char")) type=0;
    else if (strstr(argv[2], "Short")) type=1;
    else if (strstr(argv[2], "ULong")) type=3;
    else if (strstr(argv[2], "Long")) type=2; 
    else if (strstr(argv[2], "Int64")) type=4;
    else if (strstr(argv[2], "Float")) type=5;
    else if (strstr(argv[2], "Double")) type=6;
    else if (strstr(argv[2], "Str")) type=7;
    else {
      print_usage(argv[0]);
		  return -1;
    }
    addr = atoi(argv[3]); 
    switch(type) {
        case 0:
          if (rw_flag==1)  c_value=(char)atoi(argv[4]);
          break;
        case 1:
          if (rw_flag==1)  s_value=(short)atoi(argv[4]);
          break;
        case 2:
          if (rw_flag==1)  l_value=atol(argv[4]);
          break;
        case 3:
          if (rw_flag==1)  ul_value=strtoul(argv[4], NULL, 0);
          break;
        case 4:
          if (rw_flag==1)  ll_value=atoll(argv[4]);
          break;
        case 5:
          if (rw_flag==1)  f_value=(float)atof(argv[4]);
          break;
        case 6:
          if (rw_flag==1)  d_value=atof(argv[4]);
          break;
        case 7:
          if (rw_flag==1) sprintf(str_value,"%s",argv[4]);
          break;
    }
  }
  
  UserShare_Init();
  switch(type) {
    case 0:
      if (rw_flag==1) {
        ret=UserShare_Set_Char(addr, c_value);
        printf("Set_Char: ret=%d, addr=%d, value=%d\n", ret, addr, c_value);
      }
      else {
        ret=UserShare_Get_Char(addr, &c_value);
        printf("Get_Char: ret=%d, addr=%d, value=%d\n", ret, addr, c_value);
      }
      break;
    case 1:
      if (rw_flag==1) {
        ret=UserShare_Set_Short(addr, s_value);
        printf("Set_Short: ret=%d, addr=%d, value=%d\n", ret, addr, s_value);
      }
      else {
        ret=UserShare_Get_Short(addr, &s_value);
        printf("Get_Short: ret=%d, addr=%d, value=%d\n", ret, addr, s_value);
      }
      break;
    case 2:
      if (rw_flag==1) {
        ret=UserShare_Set_Long(addr, l_value);
        printf("Set_Long: ret=%d, addr=%d, value=%ld\n", ret, addr, l_value);
      }
      else {
        ret=UserShare_Get_Long(addr, &l_value);
        printf("Get_Long: ret=%d, addr=%d, value=%ld\n", ret, addr, l_value);
      }
      break;
    case 3:
      if (rw_flag==1) {
        ret=UserShare_Set_ULong(addr, ul_value);
        printf("Set_ULong: ret=%d, addr=%d, value=%lu\n", ret, addr, ul_value);
      }
      else {
        ret=UserShare_Get_ULong(addr, &ul_value);
        printf("Get_ULong: ret=%d, addr=%d, value=%lu\n", ret, addr, ul_value);
      }
      break;
    case 4:
      if (rw_flag==1) {
        ret=UserShare_Set_Int64(addr, ll_value);
        printf("Set_Int64: ret=%d, addr=%d, value=%lld\n", ret, addr, ll_value);
      }
      else {
        ret=UserShare_Get_Int64(addr, &ll_value);
        printf("Get_Int64: ret=%d, addr=%d, value=%lld\n", ret, addr, ll_value);
      }
      break;
    case 5:
      if (rw_flag==1) {
        ret=UserShare_Set_Float(addr, f_value);
        printf("Set_Float: ret=%d, addr=%d, value=%f\n", ret, addr, f_value);
      }
      else {
        ret=UserShare_Get_Float(addr, &f_value);
        printf("Get_Float: ret=%d, addr=%d, value=%f\n", ret, addr, f_value);
      }
      break;
    case 6:
      if (rw_flag==1) {
        ret=UserShare_Set_Double(addr, d_value);
        printf("Set_Double: ret=%d, addr=%d, value=%lf\n", ret, addr, d_value);
      }
      else {
        ret=UserShare_Get_Double(addr, &d_value);
        printf("Get_Double: ret=%d, addr=%d, value=%lf\n", ret, addr, d_value);
      }
      break;
    case 7:
      if (rw_flag==1) {
        ret=UserSetReg_Str(addr, str_value, strlen(str_value));
        printf("SetReg_Str: ret=%d, addr=%d, value=%s\n", ret, addr, str_value);
      }
      else {
        ret=UserGetReg_Str(addr, str_value, 256);
        printf("GetReg_Str: ret=%d, addr=%d, value=%s\n", ret, addr, str_value);
      }
      break;
  } 
  
	return ret;
}

